﻿using Syncfusion.Pdf;
using System.Collections.Generic;
using System.IO;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using Syncfusion.Drawing;
using System;
using System.Reflection;
using Syncfusion.Pdf.Interactive;
using System.Collections;
using System.Reflection.Metadata;
using System.Xml.Linq;
using System.Diagnostics;
using System.Reflection.Metadata.Ecma335;
using Syncfusion.Pdf.Barcode;
using System.Drawing;
using RectangleF = Syncfusion.Drawing.RectangleF;
using Color = Syncfusion.Drawing.Color;
using PointF = Syncfusion.Drawing.PointF;
using SizeF = Syncfusion.Drawing.SizeF;



Syncfusion.Licensing.SyncfusionLicenseProvider.RegisterLicense("Your License Key");

//Creates a new PDF document

//PdfDocument document = new PdfDocument();

FileStream input = new FileStream("../../../Data/Sample.pdf", FileMode.Open, FileAccess.ReadWrite);

PdfLoadedDocument document = new PdfLoadedDocument(input);


//Creates a certificate instance from PFX file with private key

FileStream certificateStream = new FileStream("../../../Data/PDF.pfx", FileMode.Open, FileAccess.Read);

PdfCertificate pdfCert = new PdfCertificate(certificateStream, "password123");

//Creates a digital signature

PdfSignature signature = new PdfSignature(document, document.Pages[0], pdfCert, "Signature");

//Sets an image for signature field

;

signature.Bounds = GetCorrectedBounds(document.Pages[0] as PdfLoadedPage, new RectangleF(0, 400, 200, 100));

PdfLoadedPage ldPage = document.Pages[0] as PdfLoadedPage;

signature.ContactInfo = "johndoe@owned.us";

signature.LocationInfo = "Honolulu, Hawaii";

signature.Reason = "I am author of this document.";

//Create appearance for the digital siganture

var angle = ldPage.Rotation;
DrawRotateSignatureAppeareance(signature, signature.Appearance.Normal.Graphics, angle, signature.Bounds);


//Save the document into stream

MemoryStream ms = new MemoryStream();
document.Save(ms);

//PdfLoadedDocument loadedDocument = new PdfLoadedDocument(ms);
//loadedDocument.Form.Flatten = true;
//loadedDocument.Save(ms);

File.WriteAllBytes("../../../NewOutput.pdf", ms.ToArray());
ms.Position = 0;

document.Close();


static void DrawRotateSignatureAppeareance(PdfSignature signature, PdfGraphics graphics, PdfPageRotateAngle angle, RectangleF bounds)
{
    FileStream signatureImageStream = new FileStream("../../../Data/signature.png", FileMode.Open, FileAccess.Read);
    PdfBitmap signatureImage = new PdfBitmap(signatureImageStream);

    graphics.Save();
    if (angle == PdfPageRotateAngle.RotateAngle90)
    {
        graphics.TranslateTransform(0, bounds.Height);
        graphics.RotateTransform(-90);

    }
    else if (angle == PdfPageRotateAngle.RotateAngle180)
    {
        graphics.TranslateTransform(bounds.Width, bounds.Height);
        graphics.RotateTransform(-180);

    }
    else if (angle == PdfPageRotateAngle.RotateAngle270)
    {
        graphics.TranslateTransform(bounds.Width, 0);
        graphics.RotateTransform(-270);
    }

    PdfFont font = new PdfStandardFont(PdfFontFamily.Helvetica, 6);
    RectangleF imageArea = new RectangleF();
    if (angle == PdfPageRotateAngle.RotateAngle90 || angle == PdfPageRotateAngle.RotateAngle270)
        imageArea = new RectangleF(new PointF(0, 0), new SizeF(signature.Bounds.Size.Height / 3, signature.Bounds.Size.Width));
    else
        imageArea = new RectangleF(new PointF(0, 0), new SizeF(signature.Bounds.Size.Width / 3, signature.Bounds.Size.Height));
    signature.Appearance.Normal.Graphics.DrawImage(signatureImage, imageArea);

    //Drawtext area
    RectangleF textArea = new RectangleF();
    if (angle == PdfPageRotateAngle.RotateAngle90 || angle == PdfPageRotateAngle.RotateAngle270)
        textArea = new RectangleF(new PointF((signature.Bounds.Size.Height / 3) + 2, 0), new SizeF(signature.Bounds.Size.Height / (signatureImageStream != null ? 3 : 1), signature.Bounds.Size.Width));
    else
        textArea = new RectangleF(new PointF((signature.Bounds.Size.Width / 3) + 2, 0), new SizeF(signature.Bounds.Size.Width / (signatureImageStream != null ? 3 : 1), signature.Bounds.Size.Height));


    //Draw text
    graphics.DrawString(String.Format("{0} on {1}", signature.ContactInfo, DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss +03'00'").Replace("+0300", "+03\'00\'")), font, PdfBrushes.Black, textArea, new PdfStringFormat(PdfTextAlignment.Left, PdfVerticalAlignment.Top));

    graphics.Restore();
}

static RectangleF GetCorrectedBounds(PdfLoadedPage page, RectangleF bounds)
{
    SizeF pagesize = page.Size;
    RectangleF rectangle = new RectangleF(bounds.X, bounds.Y, bounds.Width, bounds.Height); if (page.Rotation == PdfPageRotateAngle.RotateAngle90)
    {
        rectangle.X = pagesize.Height - (bounds.Y + bounds.Height); // bounds.Y;
        rectangle.Y = bounds.X;
        rectangle.Width = bounds.Height;
        rectangle.Height = bounds.Width;
    }
    else if (page.Rotation == PdfPageRotateAngle.RotateAngle270)
    {
        rectangle.X = pagesize.Width - (bounds.X + bounds.Width);
        rectangle.Y = bounds.Y;
        rectangle.Width = bounds.Height;
        rectangle.Height = bounds.Width;
    }
    else if (page.Rotation == PdfPageRotateAngle.RotateAngle180)
    {
        rectangle.X = pagesize.Width - (bounds.X + bounds.Width);
        rectangle.Y = pagesize.Height - (bounds.Y + bounds.Height);
        rectangle.Width = bounds.Width;
        rectangle.Height = bounds.Height;
    }
    return rectangle;
}
